<?php
/* -----------------------------------------------------------------
Copyright (c) 2025 IT-Recht Kanzlei- https://www.it-recht-kanzlei.de
Released under the MIT License (Expat)
[https://opensource.org/licenses/MIT]
------------------------------------------------------------------ */

require_once(__DIR__.'/../../../Dependencies/Gambio/LtiHandler.php');

/**
 * Class AbstractRelevanzHttpViewController
 *
 * This controller is a common base for all relevanz front controllers.
 *
 * @category System
 */
class ItrkLegalTextInterfaceController extends HttpViewController
{
    public function actionDefault() {
        $itrkLtiHandler = new \ITRechtKanzlei\Gambio\LtiHandler();
        $lti = new \ITRechtKanzlei\LTI(
            $itrkLtiHandler,
            ltrim(gm_get_conf('INSTALLED_VERSION'), 'v'),
            require __DIR__.'/../../../version.php'
        );
        $response = $lti->handleRequest(file_get_contents('php://input'));
        return new HttpControllerResponse($response, [
            'Content-Type: application/xml; charset="utf-8"',
            //'Content-Type: text/plain; charset="utf-8"',
            'Cache-Control: must-revalidate',
        ]);
    }
}
